import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.util.*;
import java.util.prefs.*;
import javax.imageio.*;
import javax.swing.*;
import javax.swing.event.*;

//-------------------------------------
class Imgz extends JFrame {

static Imgz mf;

CDA     cda;
JButton sbar;

//-------------------------------------
boolean zoom;
CRImg   img;
Font    uif;
int     cdax, cday, maxx, maxy, winx, winy, wxp, wyp;
int     mbx, mby, ssx, ssy, uax, uay, uifs;
String  stxt, uifn, wdir;

//-------------------------------------
static final int UIFS   = 32;
static final int WXP    = 50;
static final int WYP    = 50;
static final String UIFN = "Sans";
static final String UIFNLIT = "UIFN";
static final String UIFSLIT = "UIFS";
static final String WXPLIT = "WXP";
static final String WYPLIT = "WYP";
static final String IMGXLIT = "IMGX";
static final String IMGYLIT = "IMGY";
static final String DEFDIR  = "/";
static final String DIRKEY  = "WRKDIR";

//-------------------------------------
public void AddTextToImage() {
BufferedImage wrk;
CRText	      crt;
Font          f;
FontMetrics   fm;
Graphics2D    g;
int           i, nt, x, y;
  wrk = CompatibleBI(img.img, img.ir.width, img.ir.height);
  g = wrk.createGraphics();
  g.drawImage(img.img, 0, 0, null);
  nt = img.txta.Size();
  for (i=0; i<nt; i++) {
    crt = img.txta.Get(i);
    f = new Font(crt.fn, crt.fs, crt.fh);
    g.setFont(f);
    g.setColor(crt.fc);
    g.drawString(crt.txt, crt.p.x, crt.p.y);
  }
  g.dispose();
  img.img = wrk;
}

//-------------------------------------
class AEnhance implements ActionListener {
public void actionPerformed(ActionEvent ae) {
JMenuItem     mi;
JPopupMenu    pum;
  if (img==null) return;
  pum = new JPopupMenu();
  mi = new JMenuItem("Lighten");
  mi.setMnemonic('L');
  mi.addActionListener(new AEnhanceLighten());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Darken");
  mi.setMnemonic('D');
  mi.addActionListener(new AEnhanceDarken());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Sharpen");
  mi.setMnemonic('S');
  mi.addActionListener(new AEnhanceSharpen());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("sOften");
  mi.setMnemonic('O');
  mi.addActionListener(new AEnhanceSoften());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class AEnhanceDarken implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage   wrk;
RescaleOp       rop;
  if (img==null) return;
  ZeroSelFields(img);
  wrk = CompatibleBI(img.img, img.ir.width, img.ir.height);
  rop = new RescaleOp(0.9f, 0, null);
  wrk = rop.filter(img.img, null);
  img.img = wrk;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AEnhanceLighten implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage   wrk;
RescaleOp       rop;
  if (img==null) return;
  ZeroSelFields(img);
  wrk = CompatibleBI(img.img, img.ir.width, img.ir.height);
  rop = new RescaleOp(1.1f, 0, null);
  wrk = rop.filter(img.img, null);
  img.img = wrk;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AEnhanceSharpen implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage   wrk;
ConvolveOp      cop;
float           data[] = {-1.0f,-1.0f,-1.0f,-1.0f,9.0f,-1.0f,-1.0f,-1.0f,-1.0f};
Kernel          k;
  if (img==null) return;
  ZeroSelFields(img);
  wrk = CompatibleBI(img.img, img.ir.width, img.ir.height);
  k = new Kernel(3, 3, data);
  cop = new ConvolveOp(k, ConvolveOp.EDGE_NO_OP, null);
  cop.filter(img.img, wrk);
  img.img = wrk;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AEnhanceSoften implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage   wrk;
ConvolveOp      cop;
float           data[] = {0.111f,0.111f,0.111f,0.111f,0.111f,0.111f,0.111f,0.111f,0.111f};
Kernel          k;
  if (img==null) return;
  ZeroSelFields(img);
  wrk = CompatibleBI(img.img, img.ir.width, img.ir.height);
  k = new Kernel(3, 3, data);
  cop = new ConvolveOp(k, ConvolveOp.EDGE_NO_OP, null);
  cop.filter(img.img, wrk);
  img.img = wrk;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AFile implements ActionListener {
public void actionPerformed(ActionEvent ae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Open");
  mi.setMnemonic('O');
  mi.addActionListener(new AFileOpen());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Save");
  mi.setMnemonic('S');
  mi.addActionListener(new AFileSave());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Paste");
  mi.setMnemonic('P');
  mi.addActionListener(new AFilePaste());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Close");
  mi.setMnemonic('C');
  mi.addActionListener(new AFileClose());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("New");
  mi.setMnemonic('N');
  mi.addActionListener(new AFileNew());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class AFileClose implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  img = null;
  ShowImage();
}}

//-------------------------------------
class AFileNew implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage bimg;
Graphics      g;
int           x, y;
  x = Util.GetIntValue("Width", 0, mf);
  if (x==-1) return;
  y = Util.GetIntValue("Width", x, mf);
  if (y==-1) return;
  bimg = new BufferedImage(x, y, BufferedImage.TYPE_INT_RGB);  
  g = bimg.getGraphics();  
  g.setColor(new Color(0xFFFFFFFF));
  g.fillRect(0, 0, x, y);
  g.dispose();  
  if (img==null) img = new CRImg();
  img.img = bimg;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AFileOpen implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage   wrk;
Graphics2D      g;
int             fsts;
JFileChooser    fc;
String          fn;
  fc = new JFileChooser(wdir);
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = fc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    if (img==null) img = new CRImg();
    img.f = fc.getSelectedFile();
    fn = img.f.getName();
    wdir = img.f.getPath();
    wdir = Util.DirFromPath(wdir);
    SetPreferences();
    mf.setTitle(fn);
    try {
      img.img = ImageIO.read(img.f);
    } catch (Exception x) { System.err.format("Exception: %s%n", x); }
    CalcImgDim(img);
    wrk = CompatibleBI(img.img, img.ir.width, img.ir.height);
    g = wrk.createGraphics();
    g.drawImage(img.img, 0, 0, null);
    g.dispose();
    img.img = wrk;
    ZeroSelFields(img);
    ShowImage();
    ShowImageInfo(img);
  }
}}

//-------------------------------------
class AFilePaste implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage   wrk;
Clipboard       cb;
Graphics2D      g;
  cb = Toolkit.getDefaultToolkit().getSystemClipboard();
  wrk = null;
  if (cb.isDataFlavorAvailable(DataFlavor.imageFlavor)) {
    try {
      wrk = (BufferedImage)cb.getData(DataFlavor.imageFlavor);
    } catch (Exception x) { System.err.format("Exception: %s%n", x); }
    if (wrk==null) return;
    if (img==null) img = new CRImg();
    img.img = wrk;
    CalcImgDim(img);
    wrk = CompatibleBI(img.img, img.ir.width, img.ir.height);
    g = wrk.createGraphics();
    g.drawImage(img.img, 0, 0, null);
    g.dispose();
    img.img = wrk;
    ZeroSelFields(img);
    ShowImage();
    ShowImageInfo(img);
  } else Util.DspMsg("No Image in Clipboard", mf);
}}

//-------------------------------------
class AFileSave implements ActionListener {
public void actionPerformed(ActionEvent ae) {
File      f;
int       lidx;
String    ext, fn;
  if (img==null) return;
  f = GetFileToSave(img.f);
  if (f!=null) {
    if (img.txta.Size()>0) AddTextToImage();
    img.f = f;
    fn = f.getName();
    mf.setTitle(fn);
    lidx = fn.lastIndexOf('.');
    ext = fn.substring(lidx+1, fn.length());
    try {
      ImageIO.write(img.img, ext, f);
    } catch (Exception x) { System.err.format("Exception: %s%n", x); }
    CalcImgDim(img);
    ZeroSelFields(img);
    ShowImage();
    ShowImageInfo(img);
  }
}}

//-------------------------------------
class AImage implements ActionListener {
public void actionPerformed(ActionEvent ae) {
JMenuItem     mi;
JPopupMenu    pum;
  if (img==null) return;
  pum = new JPopupMenu();
  mi = new JMenuItem("Crop");
  mi.setMnemonic('C');
  mi.addActionListener(new AImageCrop());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Size");
  mi.setMnemonic('S');
  mi.addActionListener(new AImageResize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Mirror");
  mi.setMnemonic('M');
  mi.addActionListener(new AImageMirror());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("RotateCW");
  mi.setMnemonic('R');
  mi.addActionListener(new AImageRotateCW());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("RotateCCW");
  mi.setMnemonic('W');
  mi.addActionListener(new AImageRotateCCW());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Gray");
  mi.setMnemonic('G');
  mi.addActionListener(new AImageGray());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Zoom");
  mi.setMnemonic('Z');
  mi.addActionListener(new AImageZoom());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Add");
  mi.setMnemonic('A');
  mi.addActionListener(new AImageAdd());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class AImageAdd implements ActionListener {
public void actionPerformed(ActionEvent ae) {
JMenuItem     mi;
JPopupMenu    pum;
  if (img==null) return;
  pum = new JPopupMenu();
  mi = new JMenuItem("Right");
  mi.setMnemonic('R');
  mi.addActionListener(new AImageAddRight());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Below");
  mi.setMnemonic('B');
  mi.addActionListener(new AImageAddBelow());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class AImageAddBelow implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage bimg, newi;
File          f;
Graphics      g;
int           bx, by, fsts, ix, iy;
JFileChooser  fc;
String        fn;
  fc = new JFileChooser(wdir);
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = fc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    f = fc.getSelectedFile();
    bimg = img.img;
    try {
      bimg = ImageIO.read(f);
    } catch (Exception x) { System.err.format("Exception: %s%n", x); }
    bx = bimg.getWidth();
    by = bimg.getHeight();
    ix = img.img.getWidth();
    iy = img.img.getHeight();
    newi = CompatibleBI(img.img, ix, iy+by);
    g = newi.createGraphics();
    g.drawImage(img.img, 0, 0, null);  
    g.drawImage(bimg, 0, iy, null);  
    g.dispose();
    img.img = newi;
    CalcImgDim(img);
    ZeroSelFields(img);
    ShowImage();
    ShowImageInfo(img);
  }
}}

//-------------------------------------
class AImageAddRight implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage bimg, newi;
File          f;
Graphics      g;
int           bx, by, fsts, ix, iy;
JFileChooser  fc;
String        fn;
  fc = new JFileChooser(wdir);
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = fc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    f = fc.getSelectedFile();
    bimg = img.img;
    try {
      bimg = ImageIO.read(f);
    } catch (Exception x) { System.err.format("Exception: %s%n", x); }
    bx = bimg.getWidth();
    by = bimg.getHeight();
    ix = img.img.getWidth();
    iy = img.img.getHeight();
    newi = CompatibleBI(img.img, ix+bx, iy);
    g = newi.createGraphics();
    g.drawImage(img.img, 0, 0, null);  
    g.drawImage(bimg, ix, 0, null);  
    g.dispose();
    img.img = newi;
    CalcImgDim(img);
    ZeroSelFields(img);
    ShowImage();
    ShowImageInfo(img);
  }
}}

//-------------------------------------
class AImageCrop implements ActionListener {
public void actionPerformed(ActionEvent ae) {
AffineTransform at;
BufferedImage   wrk;
Graphics2D      g;
  if (img==null) return;
  if (!img.sact) return;
  if (img.sr.width<1) return;
  if (img.ssiz) wrk = CompatibleBI(img.img, img.aspx, img.aspy);
  else wrk = CompatibleBI(img.img, img.sr.width, img.sr.height);
  g = wrk.createGraphics();
  at = AffineTransform.getTranslateInstance(-img.sr.x, -img.sr.y);
  g.drawRenderedImage(img.img, at);
  g.dispose();
  img.img = wrk;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AImageGray implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage   wrk;
Graphics        g;
  if (img==null) return;
  ZeroSelFields(img);
  wrk = new BufferedImage(img.ir.width, img.ir.height, BufferedImage.TYPE_BYTE_GRAY);  
  g = wrk.getGraphics();  
  g.drawImage(img.img, 0, 0, null);  
  g.dispose();  
  img.img = wrk;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AImageMirror implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage	wrk;
Graphics2D    g;
int           h, w;  
  if (img==null) return;
  ZeroSelFields(img);
  h = img.ir.height;
  w = img.ir.width;
  wrk = CompatibleBI(img.img, w, h);
  g = wrk.createGraphics();
  g.drawImage(img.img, 0, 0, w, h, w, 0, 0, h, null);
  g.dispose();
  img.img = wrk;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AImageResize implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage   wrk;
Graphics2D      g;
Image           simg;
int             x, y;
  if (img==null) return;
  ZeroSelFields(img);
  x = Util.GetIntValue("Width", img.ir.width, mf);
  if (x==-1) return;
  if (img.aspx>0) y=(x*img.aspy)/img.aspx;
  else y = (x*img.ir.height)/img.ir.width;
  y = Util.GetIntValue("Height", y, mf);
  if (y==-1) return;
  wrk = CompatibleBI(img.img, x, y);
  simg = img.img.getScaledInstance(x, y, Image.SCALE_AREA_AVERAGING);
  g = wrk.createGraphics();
  g.drawImage(simg, 0, 0, x, y, null);
  g.dispose();
  img.img = wrk;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AImageRotateCW implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage     wrk;
double            cx, cy, rot;
Graphics2D        g;
Image             simg;
int               diff;
  if (img==null) return;
  rot = Math.toRadians(90);
  cx = img.ir.width/2;
  cy = img.ir.height/2;
  diff = (img.ir.width-img.ir.height)/2;
  wrk = CompatibleBI(img.img, img.ir.height, img.ir.width);
  g = wrk.createGraphics();
  g.rotate(rot, cx, cy);
  g.translate(diff, diff);
  g.drawImage(img.img,null,0,0);
  g.dispose();
  img.img = wrk;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AImageRotateCCW implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage     wrk;
double            cx, cy, rot;
Graphics2D        g;
Image             simg;
int               diff;
  if (img==null) return;
  rot = Math.toRadians(-90);
  cx = img.ir.width/2;
  cy = img.ir.height/2;
  diff = (img.ir.height-img.ir.width)/2;
  wrk = CompatibleBI(img.img, img.ir.height, img.ir.width);
  g = wrk.createGraphics();
  g.rotate(rot, cx, cy);
  g.translate(diff, diff);
  g.drawImage(img.img,null,0,0);
  g.dispose();
  img.img = wrk;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AImageZoom implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  zoom = !zoom;
  if (img==null) return;
  CalcImgDim(img);
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
public void AppQuit() {
  System.exit(0);
}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  AppQuit();
}}

//-------------------------------------
class ASelection implements ActionListener {
public void actionPerformed(ActionEvent ae) {
JMenuItem     mi;
JPopupMenu    pum;
  if (img==null) return;
  pum = new JPopupMenu();
  mi = new JMenuItem("Clear");
  mi.setMnemonic('C');
  mi.addActionListener(new ASelectionClear());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Size");
  mi.setMnemonic('S');
  mi.addActionListener(new ASelectionSize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Aspect");
  mi.setMnemonic('A');
  mi.addActionListener(new ASelectionAspect());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Move");
  mi.setMnemonic('M');
  mi.addActionListener(new ASelectionMove());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class ASelectionAspect implements ActionListener {
public void actionPerformed(ActionEvent ae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("2x3");
  mi.setMnemonic('2');
  mi.addActionListener(new ASelectionAspect2x3());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("3x4");
  mi.setMnemonic('3');
  mi.addActionListener(new ASelectionAspect3x4());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("4x5");
  mi.setMnemonic('4');
  mi.addActionListener(new ASelectionAspect4x5());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("5x7");
  mi.setMnemonic('5');
  mi.addActionListener(new ASelectionAspect5x7());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("4x7");
  mi.setMnemonic('7');
  mi.addActionListener(new ASelectionAspect4x7());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("User");
  mi.setMnemonic('U');
  mi.addActionListener(new ASelectionAspectUser());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class ASelectionAspect2x3 implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  ZeroSelFields(img);
  if (img.ir.width<img.ir.height) {
    img.aspx = 2;
    img.aspy = 3;
  } else {
    img.aspx = 3;
    img.aspy = 2;
  }
  RectFromAspect(img);
  img.sact = true;
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class ASelectionAspect3x4 implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  ZeroSelFields(img);
  if (img.ir.width<img.ir.height) {
    img.aspx = 3;
    img.aspy = 4;
  } else {
    img.aspx = 4;
    img.aspy = 3;
  }
  RectFromAspect(img);
  img.sact = true;
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class ASelectionAspect4x5 implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  ZeroSelFields(img);
  if (img.ir.width<img.ir.height) {
    img.aspx = 4;
    img.aspy = 5;
  } else {
    img.aspx = 5;
    img.aspy = 4;
  }
  RectFromAspect(img);
  img.sact = true;
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class ASelectionAspect5x7 implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  ZeroSelFields(img);
  if (img.ir.width<img.ir.height) {
    img.aspx = 5;
    img.aspy = 7;
  } else {
    img.aspx = 7;
    img.aspy = 5;
  }
  RectFromAspect(img);
  img.sact = true;
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class ASelectionAspect4x7 implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  ZeroSelFields(img);
  if (img.ir.width<img.ir.height) {
    img.aspx = 4;
    img.aspy = 7;
  } else {
    img.aspx = 7;
    img.aspy = 4;
  }
  RectFromAspect(img);
  img.sact = true;
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class ASelectionAspectUser implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  ZeroSelFields(img);
  uax = Util.GetIntValue("Width", uax, mf);
  if (uax==-1) return;
  uay = Util.GetIntValue("Height", uay, mf);
  if (uay==-1) return;
  img.aspx = uax;
  img.aspy = uay;
  RectFromAspect(img);
  img.sact = true;
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class ASelectionClear implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  ZeroSelFields(img);
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class ASelectionMove implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  img.smov = !img.smov;
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class ASelectionSize implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  ZeroSelFields(img);
  ssx = Util.GetIntValue("Width", ssx, mf);
  if (ssx==-1) return;
  ssy = Util.GetIntValue("Height", ssy, mf);
  if (ssy==-1) return;
  img.aspx = ssx;
  img.aspy = ssy;
  RectFromSize(img);
  img.sact = true;
  img.smov = true;
  img.ssiz = true;
  ShowImage();
  ShowImageInfo(img);
}}

//-------------------------------------
class AText implements ActionListener {
public void actionPerformed(ActionEvent ae) {
JMenuItem     mi;
JPopupMenu    pum;
  if (img==null) return;
  pum = new JPopupMenu();
  mi = new JMenuItem("String");
  mi.setMnemonic('S');
  mi.addActionListener(new ATextString());
  mi.setFont(uif);
  pum.add(mi);
  if (img.txta.Size()>0) {
    mi = new JMenuItem("Font");
    mi.setMnemonic('F');
    mi.addActionListener(new ATextFont());
    mi.setFont(uif);
    pum.add(mi);
    mi = new JMenuItem("Modify");
    mi.setMnemonic('M');
    mi.addActionListener(new ATextModify());
    mi.setFont(uif);
    pum.add(mi);
    mi = new JMenuItem("Pick");
    mi.setMnemonic('P');
    mi.addActionListener(new ATextPick());
    mi.setFont(uif);
    pum.add(mi);
  }
  pum.show(mf, 0, 0);
  ShowImage();
}}

//-------------------------------------
class ATextFont implements ActionListener {
public void actionPerformed(ActionEvent ae) {
JMenuItem     mi;
JPopupMenu    pum;
  if (img.txta.Size()<1) return;
  pum = new JPopupMenu();
  mi = new JMenuItem("Name");
  mi.setMnemonic('N');
  mi.addActionListener(new ATextFontName());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Height");
  mi.setMnemonic('H');
  mi.addActionListener(new ATextFontHeight());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Style");
  mi.setMnemonic('S');
  mi.addActionListener(new ATextFontStyle());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Color");
  mi.setMnemonic('C');
  mi.addActionListener(new ATextFontColor());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class ATextFontColor implements ActionListener {
public void actionPerformed(ActionEvent ae) {
CRText				crt;
JColorChooser	cc;
	crt = img.txta.Get(img.sti);
  cc = new JColorChooser(crt.fc);
  crt.fc = cc.showDialog(mf, "FontColor", crt.fc);
  img.txta.Set(img.sti, crt);
  ShowImage();
}}

//-------------------------------------
class ATextFontHeight implements ActionListener {
public void actionPerformed(ActionEvent ae) {
CRText	crt;
int     nth;
	crt = img.txta.Get(img.sti);
  nth = crt.fh;
  nth = Util.GetIntValue("FontHeight", nth, mf);
  if (nth>8) crt.fh = nth;
  img.txta.Set(img.sti, crt);
  ShowImage();
}}

//-------------------------------------
class ATextFontName implements ActionListener {
public void actionPerformed(ActionEvent ae) {
CRText	crt;
Font[]		fa;
int       i, ne;
String    nfn;
String[]	sa;
  fa  = GraphicsEnvironment.getLocalGraphicsEnvironment().getAllFonts();
  ne = fa.length;
  sa = new String[ne];
  for (i=0; i<ne; i++) sa[i] = fa[i].getFontName();
  nfn = Util.GetListValue("Font", sa, mf);
  if ((nfn!=null)&&(nfn.length()>0)) {
    crt = img.txta.Get(img.sti);
    crt.fn = nfn;
    img.txta.Set(img.sti, crt);
  }
  ShowImage();
}}

//-------------------------------------
class ATextFontStyle implements ActionListener {
public void actionPerformed(ActionEvent ae) {
CRText    crt;
int       i;
String    nfs;
String[]  sa = {"Plain", "Bold", "Italic", "BoldItalic"};
  nfs = Util.GetListValue("Style", sa, mf);
  crt = img.txta.Get(img.sti);
  for (i=0; i<4; i++) if (nfs.compareTo(sa[i])==0) crt.fs = i;
  img.txta.Set(img.sti, crt);
  ShowImage();
}}

//-------------------------------------
class ATextModify implements ActionListener {
public void actionPerformed(ActionEvent ae) {
CRText    crt;
  crt = img.txta.Get(img.sti);
  crt.txt = Util.GetStringValue("String", crt.txt, mf);
  if (crt.txt.length()<1) return;
  img.txta.Set(img.sti, crt);
  ShowImage();
}}

//-------------------------------------
class ATextPick implements ActionListener {
public void actionPerformed(ActionEvent ae) {
CRText	crt;
int       i, ne;
String    ss;
String[]	sa;
  ne = img.txta.Size();
  sa = new String[ne];
  for (i=0; i<ne; i++) {
    crt = img.txta.Get(i);
    sa[i] = crt.txt;
  }
  ss = Util.GetListValue("String", sa, mf);
  for (i=0; i<ne; i++) if (ss.compareTo(sa[i])==0) img.sti = i;
  ShowImage();
}}

//-------------------------------------
class ATextString implements ActionListener {
public void actionPerformed(ActionEvent ae) {
CRText	crt;
  crt = new CRText();
  crt.txt = Util.GetStringValue("String", "", mf);
  if (crt.txt.length()<1) return;
  img.txta.Add(crt);
  img.sti = img.txta.Size() - 1;
  ShowImage();  
}}

//-------------------------------------
public void CalcAdjusted(CRImg cri) {
double  r;
int     ah, aw, ax, ay;
  r = cri.ratio;
  ah = cri.sr.height;
  aw = cri.sr.width;
  ax = cri.sr.x;
  ay = cri.sr.y;
  ah = (int)(r*ah);
  aw = (int)(r*aw);
  ax = (int)(r*ax);
  ay = (int)(r*ay);
  ax += cri.ira.x;
  ay += cri.ira.y;
  cri.sra.setBounds(ax,ay,aw,ah);
}

//-------------------------------------
public void CalcImgDim(CRImg cri) {
Dimension d;
double  r, rx, ry;
Insets  is;
int     aix, aiy, ix, iy, x, y;
  is = mf.getInsets();
  cdax = mf.getWidth();
  cday = mf.getHeight();
  cdax -= (is.left+is.right);
  cday -= (is.top+is.bottom);
  cday -= sbar.getHeight();
  ix = cri.img.getWidth();
  iy = cri.img.getHeight();
  cri.ir.setBounds(0,0,ix,iy);
  rx = ((double)cdax)/ix;
  ry = ((double)cday)/iy;
  if (rx<ry) r = rx;
  else r = ry;
  if (!zoom) if (r>1.0) r = 1.0;
  aix = (int)(r*ix);
  aiy = (int)(r*iy);
  x = (cdax-aix)/2;
  y = (cday-aiy)/2;
  cri.ira.setBounds(x,y,aix,aiy);
  cri.ratio = r;
}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  PopupMain();
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
int   kc;
  kc = ke.getKeyCode();
  if (kc == KeyEvent.VK_F1) PopupMain();
  if (kc == KeyEvent.VK_LEFT) {
    if (img.smov) MoveSelectionX(-1);
    else if (img.txta.Size()>0) MoveTextX(-1);
  }
  if (kc == KeyEvent.VK_RIGHT) {
    if (img.smov) MoveSelectionX(1);
    else if (img.txta.Size()>0) MoveTextX(1);
  }
  if (kc == KeyEvent.VK_UP) {
    if (img.smov) MoveSelectionY(-1);
    else if (img.txta.Size()>0) MoveTextY(-1);
  }
  if (kc == KeyEvent.VK_DOWN) {
    if (img.smov) MoveSelectionY(1);
    else if (img.txta.Size()>0) MoveTextY(1);
  }
  if (kc == KeyEvent.VK_HOME) {
    if (img.smov) MoveSelectionX(-10);
    else if (img.txta.Size()>0) MoveTextX(-10);
  }
  if (kc == KeyEvent.VK_END) {
    if (img.smov) MoveSelectionX(10);
    else if (img.txta.Size()>0) MoveTextX(10);
  }
  if (kc == KeyEvent.VK_PAGE_UP) {
    if (img.smov) MoveSelectionY(-10);
    else if (img.txta.Size()>0) MoveTextY(-10);
  }
  if (kc == KeyEvent.VK_PAGE_DOWN) {
    if (img.smov) MoveSelectionY(10);
    else if (img.txta.Size()>0) MoveTextY(10);
  }
  if (kc == KeyEvent.VK_E) ExpandSelection();
  if (kc == KeyEvent.VK_R) ReduceSelection();
  ShowImage();
}}

//-------------------------------------
class CBMouse extends MouseInputAdapter {
//-----------------
public void mouseClicked(MouseEvent me) {
int   x, y;
  if (img==null) return;
  x = (int)((me.getX()-img.ira.x)/img.ratio);
  y = (int)((me.getY()-img.ira.y)/img.ratio);
  SetMouseBegin(x,y);
  if (img.sact&&(!img.ssiz)) ExpandReduce(x,y);
  ShowImage();
}
//-----------------
public void mouseDragged(MouseEvent me) {
int   x, y;
  if (img==null) return;
  x = (int)((me.getX()-img.ira.x)/img.ratio);
  y = (int)((me.getY()-img.ira.y)/img.ratio);
  if (img.smov) MoveSelection(x,y);
  else if (img.txta.Size()>0) MoveText(x,y);
  ShowImage();
}
//-----------------
public void mouseReleased(MouseEvent me) {
  ShowImage();
}
}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
  cday = cda.getHeight();
  cdax = cda.getWidth();
  if (img!=null) CalcImgDim(img);
  ShowImage();
}}

//-------------------------------------
public BufferedImage CompatibleBI(BufferedImage img, int x, int y) {
boolean         iapm;
BufferedImage   rv;
ColorModel      cm;
WritableRaster  wr;
  cm = img.getColorModel();
  wr = cm.createCompatibleWritableRaster(x, y);
  iapm = cm.isAlphaPremultiplied();
  rv = new BufferedImage(cm, wr, iapm, null);
  return(rv);
}

//-------------------------------------
void ExpandReduce(int x, int y) {
int   h, w, sx, sy;
int   nh, nw;
  if (!img.sasp) return;
  sx = img.sr.x;
  sy = img.sr.y;
  w = img.sr.width;
  h = img.sr.height;
  if (img.sr.contains(x,y)) {
    nh = h - img.aspy;
    nw = w - img.aspx;
    if (nh<0) return;
    if (nw<0) return;
  } else {
    nh = h + img.aspy;
    nw = w + img.aspx;
    if ((nh+sy)>img.ir.height) return;
    if ((nw+sx)>img.ir.width) return;
  }
  img.sr.setSize(nw,nh);
}

//-------------------------------------
void ExpandSelection() {
int   h, w, x, y;
int   nh, nw;
  if (!img.sasp) return;
  x = img.sr.x;
  y = img.sr.y;
  w = img.sr.width;
  h = img.sr.height;
  nh = h + img.aspy;
  nw = w + img.aspx;
  if ((nh+y)>img.ir.height) return;
  if ((nw+x)>img.ir.width) return;
  img.sr.setSize(nw,nh);
}

//-------------------------------------
public File GetFileToSave(File inf) {
File          f;
int           fsts;
JFileChooser  fc;
  f = null;
  fc = new JFileChooser(inf);
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fc.setSelectedFile(inf);
  fsts = fc.showSaveDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    f = fc.getSelectedFile();
    wdir = f.getPath();
    wdir = Util.DirFromPath(wdir);
  }
  return(f);
}

//-------------------------------------
public Imgz(String[] args) {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
}

//-------------------------------------
public void Initlz() {
  InitlzData();
  ReadIniFile();
  InitlzUI();
  LayoutUI();
}

//-------------------------------------
public void InitlzData() {
  uifs = UIFS;
  uifn = UIFN;
  wxp = WXP;
  wyp = WYP;
  stxt = "Click Here";
}

//-------------------------------------
public void InitlzUI() {
Font f;
  winx = (maxx*wxp)/100;
  winy = (maxy*wyp)/100;
  uif = new Font(uifn, Font.BOLD, uifs);
  f = new Font(uifn, Font.BOLD, uifs/2);
  Util.PutUIManFonts(f);
  cda = new CDA();
  cda.setBackground(new Color(32, 255, 32));
  cda.addKeyListener(new CBKey());
  cda.addMouseListener(new CBMouse());
  cda.addMouseMotionListener(new CBMouse());
  cda.addComponentListener(new CBResize());
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.setBackground(new Color(16, 16, 128));
  sbar.setForeground(new Color(255, 255, 0));
}

//-------------------------------------
public void LayoutUI() {
Image     iimg;
Toolkit   tk;
URL       iurl;
  mf.setSize(winx, winy);
  mf.getContentPane().add(sbar, BorderLayout.NORTH);
  mf.getContentPane().add(cda, BorderLayout.CENTER);
  mf.setTitle("Imgz");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
  iurl = this.getClass().getResource("/Imgz.png");
  tk = Toolkit.getDefaultToolkit();
  iimg = tk.createImage(iurl);
  mf.setIconImage(iimg);
}

//-------------------------------------
public static void main(String[] args) {
  System.out.println("starting Imgz\n");
  mf = new Imgz(args);
  mf.Initlz();
}

//-------------------------------------
void MoveSelection(int x, int y) {
int   dx, dy, nx, ny;
  dx = x-mbx;
  dy = y-mby;
  nx = img.sr.x;
  ny = img.sr.y;
  nx += dx;
  ny += dy;
  if (nx<0) nx = 0;
  if (ny<0) ny = 0;
  if (nx>(img.ir.width-img.sr.width)) nx = img.ir.width-img.sr.width;
  if (ny>(img.ir.height-img.sr.height)) ny = img.ir.height-img.sr.height;
  img.sr.setLocation(nx,ny);
  mbx = x;
  mby = y;
}

//-------------------------------------
void MoveSelectionX(int ad) {
int   nx, ny;
  if (!img.sact) MoveTextX(ad);
  else {
	  nx = img.sr.x;
  	ny = img.sr.y;
  	nx += ad;
  	if (nx<0) nx = 0;
  	if (nx>(img.ir.width-img.sr.width)) nx = img.ir.width-img.sr.width;
  	img.sr.setLocation(nx,ny);
  }
}

//-------------------------------------
void MoveSelectionY(int ad) {
int   nx, ny;
  if (!img.sact) MoveTextY(ad);
  else {
    nx = img.sr.x;
    ny = img.sr.y;
    ny += ad;
   	if (ny<0) ny = 0;
  	if (ny>(img.ir.height-img.sr.height)) ny = img.ir.height-img.sr.height;
  	img.sr.setLocation(nx,ny);
  }
}

//-------------------------------------
void MoveText(int x, int y) {
CRText	crt;
int     dx, dy, nx, ny;
  crt = img.txta.Get(img.sti);
  dx = x-mbx;
  dy = y-mby;
  nx = crt.p.x;
  ny = crt.p.y;
  nx += dx;
  ny += dy;
  if (nx<0) nx = 0;
  if (ny<0) ny = 0;
  if (nx>img.ir.width) nx = img.ir.width;
  if (ny>img.ir.height) ny = img.ir.height;
  crt.p.x = nx;
  crt.p.y = ny;
  img.txta.Set(img.sti, crt);
  mbx = x;
  mby = y;
}

//-------------------------------------
void MoveTextX(int ad) {
CRText	crt;
int			nx;
  if (img.txta.Size()<1) return;
  crt = img.txta.Get(img.sti);
  nx = crt.p.x;
  nx += ad;
	if (nx<0) nx = 0;
	if (nx>img.ir.width) nx = img.ir.width;
  crt.p.x = nx;
  img.txta.Set(img.sti, crt);
}

//-------------------------------------
void MoveTextY(int ad) {
CRText	crt;
int			ny;
  if (img.txta.Size()<1) return;
  crt = img.txta.Get(img.sti);
  ny = crt.p.y;
  ny += ad;
	if (ny<0) ny = 0;
	if (ny>img.ir.height) ny = img.ir.height;
  crt.p.y = ny;
  img.txta.Set(img.sti, crt);
}

//-------------------------------------
public void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("File");
  mi.setMnemonic('F');
  mi.addActionListener(new AFile());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Image");
  mi.setMnemonic('I');
  mi.addActionListener(new AImage());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Enhance");
  mi.setMnemonic('E');
  mi.addActionListener(new AEnhance());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Selection");
  mi.setMnemonic('S');
  mi.addActionListener(new ASelection());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Text");
  mi.setMnemonic('T');
  mi.addActionListener(new AText());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(sbar, 0, 0);
}

//-------------------------------------
public void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"Imgz.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = "no ini file";
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(UIFNLIT)==0) uifn = val;
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
      }
    }
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//-------------------------------------
void ReadPreferences() {
Preferences p;
  try {
    p = Preferences.userRoot().node(getClass().getName());
    wdir = p.get(DIRKEY, DEFDIR);
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//-------------------------------------
void RectFromAspect(CRImg cri) {
int   h, w, x, y;
  if (cri.aspy<cri.aspx) {
    w = cri.ir.width/2;
    w -= w%cri.aspx;
    h = (w*cri.aspy)/cri.aspx;
  } else {
    h = cri.ir.height/2;
    h -= h%cri.aspy;
    w = (h*cri.aspx)/cri.aspy;
  }
  x = (cri.ir.width-w)/2;
  y = (cri.ir.height-h)/2;
  y = 0;
  cri.sr.setLocation(x,y);
  cri.sr.setSize(w,h);
  cri.sasp = true;
}

//-------------------------------------
void RectFromSize(CRImg cri) {
int     h, w, x, y;
  h = cri.aspy;
  w = cri.aspx;
  x = (cri.ir.width-w)/2;
  y = (cri.ir.height-h)/2;
  y = 0;
  if (x<0) x = 0;
  if (y<0) y = 0;
  cri.sr.setLocation(x,y);
  cri.sr.setSize(w,h);
}

//-------------------------------------
void ReduceSelection() {
int   h, w, px, py;
int   nh, nw;
  if (!img.sasp) return;
  w = img.sr.width;
  h = img.sr.height;
  nh = h - img.aspy;
  nw = w - img.aspx;
  img.sr.setSize(nw,nh);
}

//---------------------------------------------
void RenderText(Graphics g) {
CRText	crt;
Font    f;
int     afh, i, nt, x, y;
  nt = img.txta.Size();
  for (i=0; i<nt; i++) {
    crt = img.txta.Get(i);
    x = (int)(crt.p.x*img.ratio)+img.ira.x;
    y = (int)(crt.p.y*img.ratio)+img.ira.y;
    afh = (int)(crt.fh*img.ratio);
    f = new Font(crt.fn, crt.fs, afh);
    g.setFont(f);
    g.setColor(crt.fc);
    g.drawString(crt.txt, x, y);
  }
}

//-------------------------------------
void SetMouseBegin(int x, int y) {
String  s;
  mbx = x;
  mby = y;
}

//-------------------------------------
void SetPreferences() {
Preferences p;
  p = Preferences.userRoot().node(getClass().getName());
  p.put(DIRKEY, wdir);
}

//-------------------------------------
void ShowImage() {
BufferedImage wrk;
Graphics      g;
  if (img==null) return;
  CalcAdjusted(img);
  wrk = CompatibleBI(img.img, cdax, cday);
  g = wrk.getGraphics();  
  g.drawImage(img.img, img.ira.x, img.ira.y, img.ira.width, img.ira.height, null);
  if (img.sact) {
    g.setColor(new Color(0xFFFF8080));
    g.drawRect(img.sra.x, img.sra.y, img.sra.width, img.sra.height);
  }
  if (img.txta.Size()>0) RenderText(g);
  cda.img = wrk;
  cda.repaint();
  cda.requestFocusInWindow();
}

//-------------------------------------
void ShowImageInfo(CRImg cri) {
String    s;
  s = Integer.toString(cri.ir.width);
  s += " x ";
  s += Integer.toString(cri.ir.height);
  if (cri.smov) s += " Move Selection";
  else if (cri.sasp) s += " Expand Reduce";
  sbar.setText(s);
}

//-------------------------------------
void ZeroSelFields(CRImg cri) {
  cri.sact = false;
  cri.sasp = false;
  cri.smov = false;
  cri.ssiz = false;
  cri.aspx = 0;
  cri.aspy = 0;
  cri.sr.setLocation(0,0);
  cri.sr.setSize(0,0);
  cri.sra.setLocation(0,0);
  cri.sra.setSize(0,0);
}

//-------------------------------------
}
